//###############################################################
//# mask2_slots.h for ProcessViewServer created: So. Juni 21 13:00:07 2020
//# please fill out these slots
//# here you find all possible events
//# Yours: Lehrig Software Engineering
//###############################################################

// todo: uncomment me if you want to use this data aquisiton
// also uncomment this classes in main.cpp and pvapp.h
// also remember to uncomment rllib in the project file
//extern rlModbusClient     modbus;  //Change if applicable
//extern rlSiemensTCPClient siemensTCP;
//extern rlPPIClient        ppi;

typedef struct // (todo: define your data structure here)
{
  int cursor;
  rlString line;
  rlSpreadsheetRow *row;
}
DATA;

static int drawCairo(PARAM *p, DATA *d, pvCairo::surfaceToUse surface=pvCairo::SVG_QDraw, const char *surface_file=NULL)
{
  if(p==NULL || d==NULL) return -1;
  pvCairo cairo;
  pvCairoWidget cw;
  cairo.setSurfaceToUse(surface,surface_file);
  //cairo.setSurfaceToUse(pvCairo::SVG_file,"test.svg");
  int width = 1280;
  int height = 1024;
  cairo_t *cr = cairo.beginDraw(p,draw1,width,height);

  // draw info
  cairo_set_font_size(cr, 14);
  cairo_select_font_face(cr, "Courier",
      CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
  cairo_set_source_rgb(cr, 0, 0, 0);
  //drawInfo(cr,d);
  pvCairoWidget::drawText(cr,100,100,"Enter text (Abort == ESC):");
  cairo_set_line_width(cr, 3.0);
  cairo_move_to(cr,95,110);
  cairo_line_to(cr,595,110);
  cairo_line_to(cr,595,130);
  cairo_line_to(cr,95,130);
  cairo_line_to(cr,95,110);
  cairo_stroke(cr);
  pvCairoWidget::drawText(cr,100,123,d->row->text(1));
  d->cursor++;
  if(d->cursor < 2)
  {
    rlString buf = d->line.text(); buf += "|";
    pvCairoWidget::drawText(cr,110,123,buf.text());
  }
  else
  {
    pvCairoWidget::drawText(cr,110,123,d->line.text());
    d->cursor = 0;
  }
  cairo_select_font_face(cr, "Arial",
      CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);

  //rlSpreadsheetRow *row = d->widgetTable.getFirstRow();
  //while(row != NULL)
  //{
  //  drawWidget(cr,&cw,row);
  //  row = row->getNextRow();
  //}

  cairo.endDraw(p);
  return 0;
}

static int slotInit(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  //memset(d,0,sizeof(DATA));
  d->cursor = 0;
  d->row = (rlSpreadsheetRow *) p->user;
  d->row->printf(2,"");
  drawCairo(p,d);
  return 0;
}

static int slotNullEvent(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  drawCairo(p,d);
  return 0;
}

static int slotButtonEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotButtonPressedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotButtonReleasedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTextEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotSliderEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotCheckboxEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotRadioButtonEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotGlInitializeEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlPaintEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlResizeEvent(PARAM *p, int id, DATA *d, int width, int height)
{
  if(p == NULL || id == 0 || d == NULL || width < 0 || height < 0) return -1;
  return 0;
}

static int slotGlIdleEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTabEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotTableTextEvent(PARAM *p, int id, DATA *d, int x, int y, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || text == NULL) return -1;
  return 0;
}

static int slotTableClickedEvent(PARAM *p, int id, DATA *d, int x, int y, int button)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || button < 0) return -1;
  return 0;
}

static int slotSelectionEvent(PARAM *p, int id, DATA *d, int val, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || text == NULL) return -1;
  return 0;
}

static int slotClipboardEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == -1 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotRightMouseEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  //pvPopupMenu(p,-1,"Menu1,Menu2,,Menu3");
  return 0;
}

static int slotKeyboardEvent(PARAM *p, int id, DATA *d, int val, int modifier)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || modifier < -1000) return -1;
  if(val == Key_Escape) return 2;
  if(val == 0x0d)       
  {
    rlSpreadsheetRow *row = (rlSpreadsheetRow *) p->user;
    row->printf(2,"%s", d->line.text());
    return 1; // CR
  }
  else if(val == 0x0a)       
  {
  }
  else if(val == 0x08) // BS
  {
    if(strlen(d->line.text()) > 0)
    {
      char *cptr = d->line.text();
      int len = strlen(cptr);
      cptr[len-1] = '\0';
    }
  }
  else
  {
    char buf[10];
    sprintf(buf,"%c",val);
    d->line += buf;
  }
  drawCairo(p,d);
  return 0;
}

static int slotMouseMovedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMousePressedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 1;
}

static int slotMouseReleasedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMouseOverEvent(PARAM *p, int id, DATA *d, int enter)
{
  if(p == NULL || id == 0 || d == NULL || enter < -1000) return -1;
  return 0;
}

static int slotUserEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}
