//***************************************************************************
//                          main.cpp  -  description
//                             -------------------
//  begin            : Mi. Aug. 10 08:20:49 2022
//  generated by     : pvdevelop (C) Lehrig Software Engineering
//  email            : lehrig@t-online.de
//***************************************************************************
#include "pvapp.h"
// todo: comment me out. you can insert these objects as extern in your masks.
// Change "modbus"(Change if applicable) and "modbusdaemon_" with the "name" of your file "name.mkmodbus".
//rlModbusClient     modbus(modbusdaemon_MAILBOX,modbusdaemon_SHARED_MEMORY,modbusdaemon_SHARED_MEMORY_SIZE);
//rlSiemensTCPClient siemensTCP(siemensdaemon_MAILBOX,siemensdaemon_SHARED_MEMORY,siemensdaemon_SHARED_MEMORY_SIZE);
//rlPPIClient        ppi(ppidaemon_MAILBOX,ppidaemon_SHARED_MEMORY,ppidaemon_SHARED_MEMORY_SIZE);

// askFritzbox code begin
#include "rlsocket.h"
#include "rlstring.h"
#include "rlthread.h"
#include "rltime.h"
rlString opt_arg_sid("9c1da2c5a1420770");
int startAskFritzbox();
// askFritzbox code end

int pvMain(PARAM *p)
{
int ret;

  pvSendVersion(p);
  pvSetCaption(p,"fritzbox-pvs");
  pvResize(p,0,1280,1024);
  //pvScreenHint(p,1024,768); // this may be used to automatically set the zoomfactor
  ret = 1;
  pvGetInitialMask(p);
  if(strcmp(p->initial_mask,"mask1") == 0) ret = 1;

  while(1)
  {
    if(trace) printf("show_mask%d\n", ret);
    switch(ret)
    {
      case 1:
        pvStatusMessage(p,-1,-1,-1,"mask1");
        ret = show_mask1(p);
        break;
      default:
        return 0;
    }
  }
}

#ifdef USE_INETD
int xmain(int ac, char **av)
{
PARAM p;

  pvInit(ac,av,&p);
  /* here you may interpret ac,av and set p->user to your data */
  pvMain(&p);
  return 0;
}
#else  // multi threaded server
int main(int ac, char **av)
{
PARAM p;
int   s;

  // askFritzbox code begin
  for(int i=1; i<ac; i++)
  {
    const char *arg = av[i];
    if(strncmp(arg,"-h",2) == 0 || strncmp(arg,"--h",3) == 0 )
    {
      printf("Template pvserver for Fritz!Box webservices:\n");
      printf("usage: %s <sid=string>\n", av[0]);
      printf("\n");
    }
    else if(strncmp(arg,"-sid=",5) == 0)
    {
      opt_arg_sid = &arg[5];
      char *cptr;
      cptr  = strchr(opt_arg_sid.text(),0x0d);
      if(cptr != NULL) *cptr = '\0';
      cptr  = strchr(opt_arg_sid.text(),0x0a);
      if(cptr != NULL) *cptr = '\0';
    }
  }
  // askFritzbox code end
  pvInit(ac,av,&p);
  startAskFritzbox();
  /* here you may interpret ac,av and set p->user to your data */
  while(1)
  {
    s = pvAccept(&p);
    if(s != -1) pvCreateThread(&p,s);
  }
  return 0;
}
#endif

// askFritzbox follows

int mytest1(rlSocket *sock)
{
  int ret;
  rlString tel,xml;
  char mybuf[4096],*cptr,*end;
  int  timeout = 10000; // milliseconds

  tel = "";
  //tel += "GET /webservices/homeautoswitch.lua?switchcmd=getdevicelistinfos&sid=1aaf44fda2a1199b HTTP/1.1"; tel += rlCRLF;
  tel += "GET /webservices/homeautoswitch.lua?switchcmd=getdevicelistinfos&sid="; tel+= opt_arg_sid; tel += " HTTP/1.1"; tel += rlCRLF;
  tel += "Host: 192.168.1.1"; tel += rlCRLF;
  tel += "User-Agent: fritzbox-pvs 1.0"; tel += rlCRLF;
  tel += "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8"; tel += rlCRLF;
  tel += "Accept-Language: de,en-US;q=0.7,en;q=0.3"; tel += rlCRLF;
  tel += "Accept-Encoding: gzip, deflate"; tel += rlCRLF;
  tel += "Connection: keep-alive"; tel += rlCRLF;
  tel += "Upgrade-Insecure-Requests: 1"; tel += rlCRLF;
  tel += rlCRLF;
      
  printf("\nGET-1\n%s\n",tel.text());
  
  ret = sock->write(tel.text(),strlen(tel.text()));
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf1 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf2 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  
  
  return 0;
}

int mytest2(rlSocket *sock)
{
  int ret;
  rlString tel,xml;
  char mybuf[4096];
  int  timeout = 10000; // milliseconds

  // test messages from: https://avm.de/fileadmin/user_upload/Global/Service/Schnittstellen/AVM_TR-064_first_steps.pdf
  // chapter: Examples

  // 10.3 Service description request from application
  /*
  // Unicast HTTP GET request message from application to CPE using values of SSDP
  // discovery response message LOCATION header.
  tel = "";
  tel += "GET /tr64desc.xml HTTP/1.1";                       tel += rlCRLF;
  tel += "Host: 192.168.1.1:49000";                          tel += rlCRLF;
  tel += "Connection: close";                                tel += rlCRLF;
  tel += "User-Agent: fritzbox-pvs 1.0";                     tel += rlCRLF;
  tel += "";                                                 tel += rlCRLF;
  printf("\ntel GET1:\n%s\n",tel.text());
  
  ret = sock->write(tel.text(),strlen(tel.text()));
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf1 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf2 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  */

  // 0.5 soap request with action getsecurityport
  // Unicast SOAP message from application to CPE using values from SCPD description file
  // and SSDP discovery response message
  xml = "";
  xml += "<?xml version=\"1.0\"?>";                                             tel += rlCRLF;
  xml += "<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\"";   tel += rlCRLF;
  xml += "s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">";      tel += rlCRLF;
  xml += "<s:Body>";                                                            tel += rlCRLF;
  xml += "<u:GetSecurityPort xmlns:u=\"urn:dslforum-org:service:DeviceInfo:1\"></u:GetSecurityPort>"; tel +=rlCRLF;
  xml += "</s:Body>";                                                           tel += rlCRLF;
  xml += "</s:Envelope>";  //murx                                                     tel += rlCRLF;
  //murx xml += "";
  int xlen = strlen(xml.text());
  char clen[80];
  sprintf(clen,"%d",xlen);
  tel = "";
  tel += "POST /upnp/control/deviceinfo HTTP/1.1";           tel += rlCRLF;
  tel += "Host: 192.168.1.1:49000";                          tel += rlCRLF;
  tel += "Content-Length: "; tel += clen;                    tel += rlCRLF;                        
  tel += "Content-Type: text/xml; charset=\"utf-8\"";        tel += rlCRLF;    
  tel += "SOAPACTION: \"urn:dslforum-org:service:DeviceInfo:1#GetSecurityPort\""; tel += rlCRLF;
  tel += "User-Agent: fritzbox-pvs 1.0";                     tel += rlCRLF;
  tel += "";                                                 tel += rlCRLF;
  tel += xml.text();
  printf("\ntel POST1:\n%s\n",tel.text());

  ret = sock->write(tel.text(),strlen(tel.text()));
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf1 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  int secport = -1;
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf2 = %s\n", mybuf);
    char *cptr = strstr(mybuf,"<NewSecurityPort>");
    if(cptr != NULL) sscanf(cptr,"<NewSecurityPort>%d",&secport);
    if(ret <= 2) break;
    if(strstr(mybuf,"</s:Body>") != NULL) break;
  }
  printf("NewSecurityPort=%d\n",secport);
  int mylen = strlen("</s:Envelope>");
  ret = sock->read(mybuf,mylen,timeout);
  mybuf[mylen] = '\0';
  if(trace) printf("buf3 = %s\n", mybuf);

  //ret = sock->disconnect();
  //if(trace) printf("ret=%d //sock.disconnect(...) mach holen des <NewSecurityPort>\n", ret);
  //rlsleep(5000);
  //ret = sock->connect();   // connect to <NewSecurityPort>
  //if(trace) printf("ret=%d //sock.connect(...) mit port %d\n", ret, secport);

  // 10.7.1 Initial Client Request
  xml = "";
  xml += "<?xml version=\"1.0\" encoding=\"utf-8\"?>";                                 xml += rlCRLF;
  xml += "<s:Envelope s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"";  xml += rlCRLF;
  xml += "xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\" >";                    xml += rlCRLF;
  xml += "<s:Header>";                                                                 xml += rlCRLF;
  xml += "<h:InitChallenge";                                                           xml += rlCRLF;
  xml += "xmlns:h=\"http://soap-authentication.org/digest/2001/10/\"";                 xml += rlCRLF;
  xml += "s:mustUnderstand=\"1\">";                                                    xml += rlCRLF;
  xml += "<UserID>fritz0195</UserID>";                                                 xml += rlCRLF;
  xml += "</h:InitChallenge >";                                                        xml += rlCRLF;
  xml += "</s:Header>";                                                                xml += rlCRLF;
  xml += "<s:Body>";                                                                   xml += rlCRLF;
  xml += "<u:GetHostNumberOfEntries xmlns:u=\"urn:dslforum-org:service:Hosts:1\">";    xml += rlCRLF;
  xml += "</u:GetHostNumberOfEntries>";                                                xml += rlCRLF;
  xml += "</s:Body>";                                                                  xml += rlCRLF;
  xml += "</s:Envelope>";                                                              xml += rlCRLF;
  xml += "";
  xlen = strlen(xml.text()); // xlen  declared at: 0.5 soap request with action getsecurityport
  sprintf(clen,"%d",xlen);   // clean declared at: 0.5 soap request with action getsecurityport
  tel = "";
  tel += "POST /upnp/control/deviceinfo HTTP/1.1";           tel += rlCRLF;
  tel += "Host: 192.168.1.1:49000";                          tel += rlCRLF;
  tel += "Content-Length: "; tel += clen;                    tel += rlCRLF;                        
  tel += "Content-Type: text/xml; charset=\"utf-8\"";        tel += rlCRLF;    
  tel += "SOAPACTION: \"urn:dslforum-org:service:DeviceInfo:1#InitialClientRequest\""; tel += rlCRLF;
  tel += "User-Agent: fritzbox-pvs 1.0";                     tel += rlCRLF;
  tel += "";                                                 tel += rlCRLF;
  tel += xml.text();

  printf("\ntel POST2:\n%s\n",tel.text());
  
//#ifdef RLUNIX
//  ret = ::send(sock->s,tel.text(),strlen(tel.text()),MSG_DONTWAIT);
//#else
  ret = sock->write(tel.text(),strlen(tel.text()));
//#endif  

  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf1 = %s\n", mybuf);
    if(ret <= 2) break;
  }

  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf2 = %s\n", mybuf);
    if(ret <= 2) break;
  }

  while(1)
  {
    ret = sock->read(mybuf,1,timeout);
    if(trace) printf("buf3 = %c\n", mybuf[0]);
    if(ret < 0) break;
  }

  //mylen = strlen("</s:Envelope>");
  //ret = sock->read(mybuf,mylen,timeout);
  //mybuf[mylen] = '\0';
  //if(trace) printf("buf3 = %s\n", mybuf);

  return 0;
}

int mytest3(rlSocket *sock)
{
  int ret;
  rlString tel,xml;
  char mybuf[4096],*cptr,*end;
  char *sid, *challenge, *blocktime, *rights, *userlast;
  int  timeout = 10000; // milliseconds

  // try to authorize and get an SID
  tel += "";
  tel += "GET /login_sid.lua?version=2 HTTP/1.1"; tel += rlCRLF;
  tel += "Accept-Encoding: identity";             tel += rlCRLF;
  tel += "Host: 192.168.1.1";                     tel += rlCRLF;
  tel += "User-Agent: fritzbox-pvs 1.0";          tel += rlCRLF;
  tel += "Connection:.close";                     tel += rlCRLF;
  tel += rlCRLF;

  printf("\nGET-1\n%s\n",tel.text());
  
  ret = sock->write(tel.text(),strlen(tel.text()));
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf1 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  // buf2 = alles in 1 zeile, beispiel folgt 
  // <?xml version="1.0" encoding="utf-8"?><SessionInfo><SID>0000000000000000</SID>
  // <Challenge>2$60000$d5eea4f8d9180d3d4dce01b6b590635f$6000$3b456909e77d0ff5fa9ffa1f4f6c6aeb</Challenge>
  // <BlockTime>0</BlockTime>
  // <Rights></Rights>
  // <Users><User last="1">fritz0195</User></Users></SessionInfo>
  sid = challenge = blocktime = rights = userlast = NULL;
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf2 = %s\n", mybuf);
    if(strstr(mybuf,"<?xml") != NULL)
    {
      cptr = strstr(mybuf,"<SID>");
      if(cptr != NULL) sid = cptr;
      cptr = strstr(mybuf,"<Challenge>");
      if(cptr != NULL) challenge = cptr;
      cptr = strstr(mybuf,"<BlockTime>");
      if(cptr != NULL) blocktime = cptr;
      cptr = strstr(mybuf,"<Rights>");
      if(cptr != NULL) rights = cptr;
      cptr = strstr(mybuf,"<User last=");
      if(cptr != NULL) userlast = cptr;
    }
    if(ret <= 2) break;
  }

  end = strstr(sid,"</SID>");
  if(end != NULL) *end = '\0';
  end = strstr(challenge,"</Challenge>");
  if(end != NULL) *end = '\0';
  end = strstr(blocktime,"</BlockTime>");
  if(end != NULL) *end = '\0';
  end = strstr(rights,"</Rights>");
  if(end != NULL) *end = '\0';
  end = strstr(userlast,"</User>");
  if(end != NULL) *end = '\0';

  cptr = strstr(sid,">");
  if(cptr != NULL) { cptr++; sid = cptr; }
  cptr = strstr(challenge,">");
  if(cptr != NULL) { cptr++; challenge = cptr; }
  cptr = strstr(blocktime,">");
  if(cptr != NULL) { cptr++; blocktime = cptr; }
  cptr = strstr(rights,">");
  if(cptr != NULL) { cptr++; rights = cptr; }
  cptr = strstr(userlast,">");
  if(cptr != NULL) { cptr++; userlast = cptr; }

  printf("sid=%s\n",sid);
  printf("challenge=%s\n",challenge);
  printf("blocktime=%s\n",blocktime);
  printf("rights=%s\n",rights);
  printf("userlast=%s\n",userlast);

  char *iter1 = strstr(challenge,"$");
  if(iter1 != NULL) iter1++;
  char *salt1 = strstr(iter1,"$");
  if(salt1 != NULL) salt1++;
  char *iter2 = strstr(salt1,"$");
  if(iter2 != NULL) iter2++;
  char *salt2 = strstr(iter2,"$");
  if(salt2 != NULL) salt2++;
  
  end = strstr(iter1,"$");
  if(end != NULL) *end = '\0';
  end = strstr(salt1,"$");
  if(end != NULL) *end = '\0';
  end = strstr(iter2,"$");
  if(end != NULL) *end = '\0';

  printf("iter1=%s\n",iter1);
  printf("salt1=%s\n",salt1);
  printf("iter2=%s\n",iter2);
  printf("salt2=%s\n",salt2);

  printf("//=== first GET is complete and we have our parameters ===\n");

  // handle the challenge
  // hash_password(userpass_murx.text(), (const unsigned char*) salt_murx.text(), r1);


  printf("//=== first POST is following ===\n");
  /*
  0x0030:  0202 c518 504f 5354 202f 6c6f 6769 6e5f  ....POST./login_
  0x0040:  7369 642e 6c75 613f 7665 7273 696f 6e3d  sid.lua?version=
  0x0050:  3220 4854 5450 2f31 2e31 0d0a 4163 6365  2.HTTP/1.1..Acce
  0x0060:  7074 2d45 6e63 6f64 696e 673a 2069 6465  pt-Encoding:.ide
  0x0070:  6e74 6974 790d 0a43 6f6e 7465 6e74 2d4c  ntity..Content-L
  0x0080:  656e 6774 683a 2031 3237 0d0a 486f 7374  ength:.127..Host
  0x0090:  3a20 3139 322e 3136 382e 312e 310d 0a55  :.192.168.1.1..U
  0x00a0:  7365 722d 4167 656e 743a 2050 7974 686f  ser-Agent:.Pytho
  0x00b0:  6e2d 7572 6c6c 6962 2f33 2e36 0d0a 436f  n-urllib/3.6..Co
  0x00c0:  6e74 656e 742d 5479 7065 3a20 6170 706c  ntent-Type:.appl
  0x00d0:  6963 6174 696f 6e2f 782d 7777 772d 666f  ication/x-www-fo
  0x00e0:  726d 2d75 726c 656e 636f 6465 640d 0a43  rm-urlencoded..C
  0x00f0:  6f6e 6e65 6374 696f 6e3a 2063 6c6f 7365  onnection:.close
  0x0100:  0d0a 0d0a                                ....
IP nb5lehrig.38584 > sx.http: tcp 127
  0x0000:  4500 00b3 a4f9 4000 4006 11eb c0a8 010f  E.....@.@.......
  0x0010:  c0a8 0101 96b8 0050 aca7 6366 bbdc b515  .......P..cf....
  0x0020:  8018 01f6 8406 0000 0101 080a ea8e 60fb  ..............`.
  0x0030:  0202 c518 7573 6572 6e61 6d65 3d66 7269  ....username=fri
  0x0040:  747a 3031 3935 2672 6573 706f 6e73 653d  tz0195&response=
  0x0050:  3965 6332 3434 3331 3865 6563 3661 3761  9ec244318eec6a7a
  0x0060:  6134 3332 3736 3538 3866 6235 3130 3932  a43276588fb51092
  0x0070:  2532 3464 3764 6436 6339 6234 3638 3462  %24d7dd6c9b4684b
  0x0080:  6334 6234 3965 3539 3339 3038 3964 3165  c4b49e5939089d1e
  0x0090:  6338 6130 3137 6232 3437 3532 6530 3265  c8a017b24752e02e
  0x00a0:  3165 6364 3437 3363 3936 3362 3736 6231  1ecd473c963b76b1
  0x00b0:  3461 61                                  4aa
  */

  xml = "";
  xml += "username=fritz0195&response=9ec244318eec6a7aa43276588fb51092%24d7dd6c9b4684bc4b49e5939089d1ec8a017b24752e02e1ecd473c963b76b14aa";
  sprintf(mybuf,"Content-Length: %d", (int) strlen(xml.text()));

  tel = "";
  tel += "POST /login_sid.lua?version=2 HTTP/1.1";          tel += rlCRLF;
  tel += "Accept-Encoding: identity";                       tel += rlCRLF;
  tel += mybuf;                                             tel += rlCRLF;
  //tel += "Content-Length: 127";                             tel += rlCRLF;
  tel += "Host: 192.168.1.1";                               tel += rlCRLF;
  tel += "User-Agent: fritzbox-pvs 1.0";                    tel += rlCRLF;
  tel += "Content-Type: application/x-www-form-urlencoded"; tel += rlCRLF;
  tel += "Connection: close";                               tel += rlCRLF;
  tel += rlCRLF;
  
  printf("\ntel POST1:\n%s\n",tel.text());
  ret = sock->connect();
  ret = sock->write(tel.text(),strlen(tel.text()));
  printf("sockwrite ret=%d\n", ret);

  printf("\ntel POST1 params:\n%s\n",xml.text());
  ret = sock->write(xml.text(),strlen(xml.text()));

  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf1 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  while(1)
  {
    ret = sock->readStr(mybuf,4000,timeout);
    if(trace) printf("buf2 = %s\n", mybuf);
    if(ret <= 2) break;
  }
  
  return 0;
}

int askFritzbox()
{
  int  trace = 1;
  int  ret = 0;
  char adr[] = "192.168.1.1";
  int  port  = 80; // used by mytest1
  //int  port  = 49000; // used for AVM TR-064 – First Steps

  rlSocket sock(adr,port,1);
  ret = sock.connect();
  if(trace) printf("ret=%d //sock.connect(...)\n", ret);

  mytest1(&sock);
  
  ret = sock.disconnect();
  if(trace) printf("ret=%d //sock.disconnect(...) ende/aus von askFritzbox()\n", ret);

  return 0;
}  

void *threadAskFritzbox(void *arg)
{
  printf("threadAskFritzbox starting.\n");
  while(1)
  {
    askFritzbox();
    rlsleep(1000*60);
  }
  return arg;
}

int startAskFritzbox()
{
  rlThread thread;
  int ret = thread.create(threadAskFritzbox,NULL);
  printf("thread.create(threadAskFritzbox) ret=%d\n", ret);
  return ret;
}
